from moteur_sans_variables.chainage import Chainage
from .noeud import Noeud
from .noeuds_testes import NoeudsTestes

class ChainageArriere(Chainage):
    """ Un moteur d'inférence à chaînage arrière. """

    def __init__(self, connaissances, unificateur):
        self.connaissances = connaissances
        self.unificateur = unificateur

    def successeurs(self, noeud):
        """ Trouve les successeurs d'un noeud. """

        print('à compléter')

    def backchain(self, noeud_depart):
        """ Exécute l'algorithme de chaînage arrière afin de trouver les\
            faits qui peuvent s'unifier avec le pattern.
        """

        print('à compléter')

    def chaine(self, pattern):
        """ Interroge le moteur de chaînage arrière (fonction d'interface). """

        # Retourne les solutions par chaînage arrière.
        noeud_depart = Noeud(pattern, pattern, [], 0)
        solutions = self.backchain(noeud_depart)

        return solutions